module enco_v3_
(
input CLK_50, res_n, 
input encA_, encB_, encC_, 
output logic [31:0] t_var_cnt, 
output logic [31:0] imp_cnt
//output bit test_inc, test_dec,
//output bit C_test, 

); 

bit A0, A1, B0, B1, C0, C1,C2,C3; 
//logic [3:0] C1;  

//param shortint  =  (nr_imp * 4) - 16'd1; 
localparam [31:0]  imp = 1000;

initial
begin A0= 1'b0; A1 = 1'b0; B0 = 1'b0; B1 = 1'b1; 
      C0 = 1'b0; C1 = 1'b0; C2 = 1'b0; C3 = 1'b0; /*C1 = 4'd0;*/ end 

always_ff@(posedge CLK_50)
begin 
A0 <= encA_; 
A1 <= A0;
end 

always_ff@(posedge CLK_50)
begin 
B0 <= encB_; 
B1 <= B0;
end 


always_ff@(negedge CLK_50 or negedge res_n)
begin 

if(~res_n)
imp_cnt <= 16'd0; 

else 
begin 

	if((({B1,B0}==2'b00)&&({A1,A0} == 2'b10))||
		(({A1,A0}==2'b00)&&({B1,B0} == 2'b01))||
		(({B1,B0}==2'b11)&&({A1,A0} == 2'b01))||
		(({A1,A0}==2'b11)&&({B1,B0} == 2'b10)))
	begin 
		
			if(imp_cnt < imp /*16'd4095*/)
			imp_cnt <= imp_cnt + 32'd1; 

			
			else 
			imp_cnt <= imp; 
		
		
	end 
		
		
	else if((({B1,B0}==2'b00)&&({A1,A0}==2'b01))||
        (({A1,A0}==2'b00)&&({B1,B0}==2'b10))||
		  (({B1,B0}==2'b11)&&({A1,A0}==2'b10))||
		  (({A1,A0}==2'b11)&&({B1,B0}==2'b01)))
	begin 
		    
			 if(imp_cnt > 0)	 
		    imp_cnt <= imp_cnt - 32'd1; 

			 
			else
			imp_cnt <= 0; /*16'd4095;*/
	end 
		
		

	else 
	imp_cnt = imp_cnt; 


end 

end 
/*
always_ff@(posedge CLK_50)
begin 
//C0 <= encC_;

if(imp_cnt == 16'd0) 
begin 
C0 <= 1'b1;
C1 <= C0; 
C2 <= C1;
C3 <= C2;
end 

else
begin 
C0 <= 1'b0;
C1 <= 1'b0; 
C2 <= 1'b0;
C3 <= 1'b0;


end 

 
end

always_ff@(negedge CLK_50)
begin 
if(({A1,A0}==2'b11)&&({B1,B0}==2'b11)&&({C0,C1,C2,C3}==4'b1110))
t_var_cnt <= imp_cnt; 


else
t_var_cnt <= t_var_cnt; 

end 
*/
/*
always_ff@(posedge CLK_50)
begin 
C0 <= encC_; 

if(C0 & A1 & A0 & B0 & B1)
begin 
if(C1 < 3'd7)
C1 <= C1 + 3'd1; 

else 
C1 <= 3'd7;
end 

else 
C1 <= 3'd0; 

end 

always_ff@(posedge CLK_50)
begin 

if(C1 == 6)
t_var_cnt <= imp_cnt; 


else
t_var_cnt <= t_var_cnt; 

end 
*/

//dla indeksu enkoderowego bez zerowania przez operatora
//assign C_test  = (({A1,A0}==2'b11)&&({B1,B0}==2'b11)&&({C0,C1,C2,C3}==4'b1110)) ? (1'b1) : (1'b0); 

//
//assign C_test  = (({C0,C1,C2,C3}==4'b1110)||({C0,C1,C2,C3}==4'b1100)||({C0,C1,C2,C3}==4'b1000)) ? (1'b1): (1'b0); 
//assign test_inc = (imp_cnt == 16'd15)? (1'b1): (1'b0);
//assign test_dec = (imp_cnt == 16'd0)? (1'b1): (1'b0);



endmodule 
