module PWM (
input CLK_50,
input res_n,
input [31:0] duty_set, 
output bit pwm_out
);

logic [31:0] cnt; 

always_ff@(posedge CLK_50 or negedge res_n)
begin

if(~res_n)
begin 
cnt = 32'd1;
end 

else 
begin 

if(cnt < 32'd10)
cnt = cnt + 32'd1; 

else 
cnt = 32'd0; 

end 
end 



always_ff@(negedge CLK_50 or negedge res_n)
begin


if(~res_n)
begin 
pwm_out = 1'b0;
end 

else 
begin 
if(duty_set < cnt)
pwm_out = 1'b0; 

else 
pwm_out = 1'b1; 
end 

end 
 
 endmodule
